<?php
header('Content-Type: text/xml; charset=UTF-8');
echo '<'.'?xml version="1.0" encoding="UTF-8" ?'.'>
<rss version="2.0" xmlns:dc="http://purl.org/dc/elements/1.1/">
';

// Defines the $lg variable
//require("getLanguage.php");

$lg="en";
// Default language is english
$txtIn="in";
$txtNoResult="No publications were found.";
$txtCloseName="Possible name misspellings";
$txtDisplayAll="Display the complete list";

if (!isset($author))    $author    = $_GET["author"];
if (!isset($display))   $display   = $_GET["display"];
if (!isset($full))      $full 	   = $_GET["full"];
if (!isset($idAuthor))  $idAuthor  = $_GET["idAuthor"];
if (!isset($nbPerPage)) $nbPerPage = $_GET["nbPerPage"];
if (!isset($pg))        $pg 	   = $_GET["pg"];
if (!isset($title))     $title 	   = $_GET["title"];
if (!isset($year))      $year 	   = $_GET["year"];

if (empty($pg)) $pg = 1;
if (empty($nbPerPage)) $nbPerPage = 20;


$option["display"]   = '';
$option["full"]      = 'true';
$option["pg"]        = '-1';

require("utils.php");
sqlConnect();


$labName="e-Motion";
$titleName=$labName;
$title="$titleName publications";
echo "<channel>
	<title>$title</title>
	<link>http://emotion.inrialpes.fr/bibemotion/</link>
	<description>E-Motion publications with basilic</description>
	<language>en</language>
	<generator>Basilic</generator>
";
unset($title); // interfers with form parameters

$title=$_GET["title"];

require("publiUtils.php");

$result = bibQueryResults($option);
$nbPublis=mysql_num_rows($result);

// Search engine
//require("search.php");


//echo $pgIndex;

// If no results were found
if ($nbPublis==0)
{
}

/**
 *
 * evite les erreurs utf8  
 */
function conv_txt_utf8($s) {
   $len = strlen($s);
   $out = "";
   $curr_char = "";
   for($i=0; $i < $len; $i++) {
       $curr_char .= $s[$i];
       if( ( ord($s[$i]) & (128+64) ) == 128) {
           //character end found
           if ( strlen($curr_char) == 2) {
               // 2-byte character check for it is greek one and convert
               if      (ord($curr_char[0])==205) $out .= $curr_char;
               else if (ord($curr_char[0])==206) $out .= $curr_char;
               else if (ord($curr_char[0])==207) $out .= $curr_char;
               else ; // non greek 2-byte character, discard character
           } else ;// n-byte character, n>2, discard character
           $curr_char = "";
       } else if (ord($s[$i]) < 128) {
           // character is one byte (ascii)
           $lechar=ord($s[$i]);
           if($lechar!=12 && $lechar!=2){
           	$out .= $curr_char;
           }
           $curr_char = "";
       }
   }
   return $out;
}


function printXML2($row)
{
  if (!$row["id"]) { die ("No publication id given"); }

//  if (($row["entry"]=="Misc") || ($row["entry"]=="Manual") ||
//      ($row["entry"]=="Unpublished") || ($row["entry"]=="Booklet"))
//    return;
/*
<item>
	<title>Navigation intentionnelle d'un robot mobile</title>
	<link>http://www-laplace.imag.fr/BP/spip.php?article69</link>

	<guid isPermaLink="true">http://www-laplace.imag.fr/BP/spip.php?article69</guid>
	<dc:date>2004</dc:date>
	<dc:format>text/html</dc:format>
	<dc:language>en</dc:language>
	<dc:creator>Pradalier, Cédric</dc:creator>
	
	<dc:publisher>Th&#232;se de doctorat INPG (Institut National Polytechnique de Grenoble) - 2004 </dc:publisher>

	<dc:type>THESE</dc:type>
	<category domain="http://www-laplace.imag.fr/BP/spip.php?rubrique92">PhD theses</category>


	<description>&lt;p class=&quot;spip&quot;&gt;Th&#232;se de doctorat INPG (Institut National Polytechnique de Grenoble);
	Encadr&#233;e par Christian Laugier.&lt;/p&gt; &lt;p class=&quot;spip&quot;&gt;&lt;a href=&quot;http://www-laplace.imag.fr/publications/Rayons/pradalier04.pdf&quot; 
	class=&quot;spip_out&quot;&gt;PDF&lt;/a&gt; (13,6 Mo)&lt;/p&gt;</description>


	<content:encoded>&lt;div class='rss_texte'&gt;&lt;p class=&quot;spip&quot;&gt;Th&#232;se de doctorat INPG (Institut National Polytechnique de Grenoble);
	Encadr&#233;e par Christian Laugier.&lt;/p&gt; &lt;p class=&quot;spip&quot;&gt;&lt;a href=&quot;http://www-laplace.imag.fr/publications/Rayons/pradalier04.pdf&quot; class=&quot;spip_out&quot;&gt;PDF&lt;/a&gt; (13,6 Mo)&lt;/p&gt;&lt;/div&gt;
	</content:encoded>
</item>
*/
  $id=$row["id"];
  $year=$row["year"];
  $bibtex=$row["bibTex"];
  $publiDir="$year/$bibtex";
  $path="/bibemotion/$publiDir";
  $readFilePath="/var/www/html/emotion2/pub/$path";
  $httpath="http://".$_SERVER[HTTP_HOST].$path;
  
  
echo "
	<title>".escapeXMLChars(iconv("ISO-8859-1","UTF-8",$row["title"]))."</title>
	<link>$httpath</link>
  	<guid isPermaLink=\"true\">$httpath</guid>
	<dc:date>$year</dc:date>
	<dc:format>text/html</dc:format>
	<dc:language>en</dc:language>
";

  $aresult = sqlQuery("SELECT first, last, url FROM authors, publiauthors WHERE authors.id = publiauthors.idAuthor AND publiauthors.idPubli=$row[id] ORDER BY rank");
  while ($arow = mysql_fetch_array($aresult))
	echo "	<dc:creator>".iconv("ISO-8859-1","UTF-8",$arow[last]).", ".iconv("ISO-8859-1","UTF-8",$arow[first])."</dc:creator>\n";
  mysql_free_result ($aresult);
  echo "<dc:publisher>";
  
$row["booktitle"] = iconv("ISO-8859-1","UTF-8", $row["booktitle"]);
$row["address"] = iconv("ISO-8859-1","UTF-8", $row["address"]);
$row["journal"] = iconv("ISO-8859-1","UTF-8", $row["journal"]);
$row["publisher"] = iconv("ISO-8859-1","UTF-8", $row["publisher"]);
$row["school"] = iconv("ISO-8859-1","UTF-8", $row["school"]);
$row["institution"] = iconv("ISO-8859-1","UTF-8", $row["institution"]);
$row["entry"] = iconv("ISO-8859-1","UTF-8", $row["entry"]);
 
  printConference($row);
  echo "</dc:publisher>\n";
  
  //'Article', 'InProceedings', 'InBook', 'Book', 'PhdThesis', 'MastersThesis', 'TechReport', 'Misc', 'Booklet', 'InCollection', 'Manual', 'Proceedings', 'Unpublished'
  //"ARTJOURNAL", "ARTCOLLOQUE", "OUVRAGE", "ARTOUVRAGE", "RAPPORT", "BREVET", "FICHELOGICIEL", "PREPUB" et .. THESE
  echo "<dc:type>";
  switch($row["entry"])
  {
    case "Article":
      echo "ARTJOURNAL";
      break;
      
    case "InProceedings":
	  echo "ARTCOLLOQUE";
      break;
      
    case "Proceedings":
    case "Book":
	  echo "OUVRAGE";
      break;
      
    case "PhdThesis":
	  echo "THESE";
      break;
	case "MastersThesis":
      echo "PREPUB";
      break;
		  
    case "TechReport":
	  echo "RAPPORT";
      break;
    	
    case "InCollection":
	  echo "ARTOUVRAGE";
      break;
	case "InBook":
      echo "ARTOUVRAGE";
      break;
	
    default:
      echo "PREPUB";
      break;
  }
  echo "</dc:type>\n";
  
	# Associated documents.
	$dresult = sqlQuery("SELECT id,type,source,size,sizeX,sizeY FROM docs,publidocs where docs.id=publidocs.idDoc AND publidocs.idPubli=$id ORDER BY type ASC,source ASC");
	while ($dresult && $drow=mysql_fetch_array($dresult))
	{
	  $type = $drow["type"];
	  $src  = $drow["source"];
	
	  $size = $drow["size"];
	  if ($size>1000000)
	    $sizeText="[".(floor(1*$size/100000)/10)."Mo]";
	  else
	    $sizeText="[".floor(1*$size/1000)."Ko]";
	
	  if ($type=="PDF") $docs.="   <a href='$src'><img src='/bibemotion/images/pdf.png' alt='$src $sizeText'/></a> &nbsp;\n";
	  if ($type=="PPT") $docs.="   <a href='$src'><img src='/bibemotion/images/ppt.png' alt='$src $sizeText'/></a> &nbsp;\n";
	  if ($type=="PS")  $docs.="   <a href='$src'><img src='/bibemotion/images/ps.png' alt='$src $sizeText'/></a> &nbsp;\n";
	
	  if (($type=="IMG") || ($type=="MOV"))
	    {
	      $ratio=1.0*$drow["sizeX"]/$drow["sizeY"];
	      $h=60.0;
	      $w=$h*$ratio;
	      $pt=13;
	      if ($w>80)
		{
		  $w=80;
		  $h=$w/$ratio;
		  $pt=13 + (60-$h)/2.0;
		}
	
	      if ($type=="MOV")
		$class=" movie";
	
	      $w=floor($w);
	      $h=floor($h);
	      $pt=floor($pt)."px";
	
	     $imgMovies .= "  <div class='thumb$class'><div style='padding-top:$pt'><a href='$path/$src'>\n";
	     $imgMovies .= "  <img src='$path/.thumbs/$src.jpg' width='$w' height='$h' alt='$src $sizeText'/></a></div></div>\n";
	    }
	
	  if ($type=="INFO")
	    {
	    if (empty($info))
	      $info=$src; // choose first info file
	    else
	      if (strstr($src,".$lg.html"))
		$info=$src; // replace if adequate language is found
	    }
	  
	  if ($type=="ABS")
	    if (empty($abstract))
	      $abstract=$src; // chose first abstract
	    else
	      if (strstr($src,".$lg.html"))
		$abstract=$src; // replace if adequate language is found
	}
  	//------------------
	echo "<description>";
	if (!empty($abstract)){ 
		$abs_texte=file_get_contents("$readFilePath/$abstract");
		//$abs_texte=mb_convert_encoding("test", "UTF-8", "auto");
		$abs_texte=conv_txt_utf8($abs_texte);
		echo escapeXMLChars($abs_texte);
		//echo escapeXMLChars($abs_texte);
	}
    echo "</description>\n";
    # Associated documents : pdf, ps and ppt first
	//if (!empty($docs))
    # Images and movies
	//if (!empty($imgMovies))
	# See also
	//if (!empty($info))
}

function displayResults2($result, $option)
{
  global $lg;
  if ($lg=="fr")
    $txtIn="en";
  else
    $txtIn="in";

  $option["fullYear"]=false;
  
  // Page limits
  $minCount=0;
  $maxCount=99999;
  
  $count=-1;
  $addHR=false;
  $stopAtNextYear=false;
  $prevYear=-1;

  while ($result && $row=mysql_fetch_array($result)){
	$count++;
	$prevYear=$row["year"];
	echo "<item>";
	printXML2($row);
	echo "</item>\n";
  }
}
displayResults2($result, $option);
echo "
</channel>
</rss>
";
?>
